import { Component, ElementRef, EventEmitter, Input, NgModule, Output, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { MatButtonModule, MatIconModule, MatMenuModule, MatToolbarModule } from '@angular/material';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var PenSpinnerComponent = (function () {
    function PenSpinnerComponent(elementRef) {
        this.elementRef = elementRef;
        this.isShow = true;
        this._defaultSpinnerSrc = './assets/images/ajax-small-loader.gif';
        this._spinnerSrc = '';
    }
    Object.defineProperty(PenSpinnerComponent.prototype, "spinnerSrc", {
        get: /**
         * @return {?}
         */
        function () {
            return (this._spinnerSrc && this._spinnerSrc.trim() && this._spinnerSrc.length > 0)
                ? this._spinnerSrc.trim()
                : this._defaultSpinnerSrc;
        },
        set: /**
         * @param {?} spinnerUrl
         * @return {?}
         */
        function (spinnerUrl) {
            this._spinnerSrc = (spinnerUrl && spinnerUrl.trim() && spinnerUrl.length > 0) ? spinnerUrl.trim() : this._defaultSpinnerSrc;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    PenSpinnerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    PenSpinnerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'pen-spinner',
                    template: "<section class=\"pen-spinner\" *ngIf=\"(isShow)\" [ngClass]=\"{ backdrop: backdrop}\"> <div class=\"pen-spinner__img-group\"> <img *ngIf=\"logoSrc\" class=\"pen-spinner__logo\" src=\"{{logoSrc}}\" /> <img class=\"pen-spinner__icon\" src=\"{{spinnerSrc}}\" /> </div> </section>",
                    styles: [".pen-spinner { position: absolute; top: 0; z-index: 1060; width: 100%; height: 100%; min-height: 50px; text-align: center; } .pen-spinner:before { content: ''; display: inline-block; height: 100%; vertical-align: middle; } .pen-spinner.backdrop { background-color: rgba(0, 0, 0, 0.15); } .pen-spinner__img-group { display: inline-block; vertical-align: middle; } .pen-spinner__logo { display: block; } .pen-spinner__icon { max-width: 40px; max-height: 40px; } "]
                },] },
    ];
    /** @nocollapse */
    PenSpinnerComponent.ctorParameters = function () { return [
        { type: ElementRef, },
    ]; };
    PenSpinnerComponent.propDecorators = {
        "logoSrc": [{ type: Input },],
        "spinnerSrc": [{ type: Input, args: ['spinnerSrc',] },],
        "backdrop": [{ type: Input },],
        "isShow": [{ type: Input },],
        "width": [{ type: Input },],
        "height": [{ type: Input },],
    };
    return PenSpinnerComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var PenSpinnerModule = (function () {
    function PenSpinnerModule() {
    }
    PenSpinnerModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    exports: [PenSpinnerComponent],
                    declarations: [PenSpinnerComponent],
                    providers: [],
                },] },
    ];
    /** @nocollapse */
    PenSpinnerModule.ctorParameters = function () { return []; };
    return PenSpinnerModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var PenNavbarComponent = (function () {
    function PenNavbarComponent() {
        this.color = 'primary';
        this.fullName = '';
        this.profileImage = '';
        this.siteLogo = '';
        this.languageList = [];
        this.profileSettingList = [];
        this.activityOwnerList = [];
        this.leftLinkList = [];
        this.rightLinkList = [];
        this.clickHomeIcon = new EventEmitter();
        this.clickToggleIcon = new EventEmitter();
        this.selectLanguage = new EventEmitter();
        this.selectProfileSetting = new EventEmitter();
        this.defaultOptions = {
            showHomeIcon: true,
            showToggleIcon: true,
            showLanguage: true,
            showProfileSettings: true
        };
        this.defaultActivityOwnerList = [];
    }
    /**
     * @return {?}
     */
    PenNavbarComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.defaultOptions = Object.assign(this.defaultOptions, this.options);
        this.defaultActivityOwnerList = this._getActivityOwnerList(this.activityOwnerList);
        this.selectedLanguage = this.selectedLanguage || { title: 'English' };
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    PenNavbarComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        if (changes["activityOwnerList"]) {
            this.defaultActivityOwnerList = this._getActivityOwnerList(changes["activityOwnerList"].currentValue);
        }
    };
    /**
     * @return {?}
     */
    PenNavbarComponent.prototype.ngDoCheck = /**
     * @return {?}
     */
    function () {
        this.defaultOptions = Object.assign(this.defaultOptions, this.options);
    };
    /**
     * @return {?}
     */
    PenNavbarComponent.prototype.onHomeIconClicked = /**
     * @return {?}
     */
    function () {
        this.clickHomeIcon.emit();
    };
    /**
     * @return {?}
     */
    PenNavbarComponent.prototype.onToggleIconClicked = /**
     * @return {?}
     */
    function () {
        this.clickToggleIcon.emit();
    };
    /**
     * @param {?} lang
     * @return {?}
     */
    PenNavbarComponent.prototype.onLanguageSelected = /**
     * @param {?} lang
     * @return {?}
     */
    function (lang) {
        this.selectLanguage.emit(lang);
        this.selectedLanguage = lang;
    };
    /**
     * @param {?} setting
     * @return {?}
     */
    PenNavbarComponent.prototype.onProfileSettingSelected = /**
     * @param {?} setting
     * @return {?}
     */
    function (setting) {
        this.selectProfileSetting.emit(setting);
    };
    /**
     * @param {?} activityOwnerList
     * @return {?}
     */
    PenNavbarComponent.prototype._getActivityOwnerList = /**
     * @param {?} activityOwnerList
     * @return {?}
     */
    function (activityOwnerList) {
        var /** @type {?} */ results = [];
        for (var /** @type {?} */ i = 0, /** @type {?} */ len = activityOwnerList.length; i < len; i++) {
            var /** @type {?} */ activityOwner = activityOwnerList[i];
            setActivityOwnerObject(activityOwner);
        }
        return results;
        /**
         * @param {?} activityOwner
         * @return {?}
         */
        function setActivityOwnerObject(activityOwner) {
            results.push(activityOwner);
            if (!activityOwner.childLevel) {
                activityOwner.childLevel = 0;
            }
            if (!activityOwner.menus) {
                return;
            }
            if (activityOwner.menus && activityOwner.menus.length) {
                var /** @type {?} */ level = activityOwner.childLevel;
                level++;
                for (var /** @type {?} */ i = 0, /** @type {?} */ len = activityOwner.menus.length; i < len; i++) {
                    var /** @type {?} */ child = activityOwner.menus[i];
                    child.childLevel = level;
                    setActivityOwnerObject(child);
                }
            }
        }
    };
    PenNavbarComponent.decorators = [
        { type: Component, args: [{
                    selector: 'pen-navbar',
                    template: "<mat-toolbar class=\"pen-navbar\" color=\"{{color}}\"> <button *ngIf=\"defaultOptions.showHomeIcon\" mat-icon-button (click)=\"onHomeIconClicked()\"> <mat-icon>home</mat-icon> </button> <button *ngIf=\"defaultOptions.showToggleIcon\" mat-icon-button (click)=\"onToggleIconClicked()\"> <mat-icon>reorder</mat-icon> </button> <a class=\"pen-uppercase\" mat-button *ngFor=\"let btn of leftLinkList\" [hidden]=\"btn.title === 'Home'\" [href]=\"btn.url\" target=\"_blank\"> <span>{{btn.title}}</span> </a> <div> <button *ngIf=\"defaultActivityOwnerList.length\" mat-icon-button [matMenuTriggerFor]=\"activityOwner\"> <mat-icon [color]=\"'primary'\">keyboard_arrow_down</mat-icon> </button> <mat-menu #activityOwner=\"matMenu\" class=\"pen-navbar__activity-owner-list\"> <a mat-menu-item *ngFor=\"let ao of defaultActivityOwnerList\" [href]=\"ao.url\" [disabled]=\"!ao.active\" target=\"_blank\"> <span class=\"pen-navbar__child-level-{{ao.childLevel}}\">{{ao.title}}</span> </a> </mat-menu> </div> <span class=\"pen-fill-space\"></span> <a class=\"pen-uppercase\" mat-button *ngFor=\"let btn of rightLinkList\" [href]=\"btn.url\" target=\"_blank\"> <span>{{btn.title}}</span> </a> <div> <button class=\"pen-uppercase\" *ngIf=\"defaultOptions.showLanguage && languageList.length\" mat-button [matMenuTriggerFor]=\"language\"> <span>{{selectedLanguage.title}}</span> <mat-icon [color]=\"'primary'\">keyboard_arrow_down</mat-icon> </button> <mat-menu #language=\"matMenu\"> <button mat-menu-item *ngFor=\"let lang of languageList\" (click)=\"onLanguageSelected(lang)\">{{lang.title}}</button> </mat-menu> </div> <div class=\"pen-navbar__profile-settings\"> <button class=\"pen-navbar__profile-button pen-uppercase\" *ngIf=\"defaultOptions.showProfileSettings && profileSettingList.length\" mat-button [matMenuTriggerFor]=\"profileSettings\"> <mat-icon *ngIf=\"!profileImage\">account_circle</mat-icon> <img class=\"pen-navbar__profile-image\" *ngIf=\"profileImage\" [src]=\"profileImage\" /> <span>{{fullName}}</span> <mat-icon [color]=\"'primary'\">keyboard_arrow_down</mat-icon> </button> <mat-menu #profileSettings=\"matMenu\" class=\"pen-navbar__profile-menu\"> <button mat-menu-item *ngFor=\"let setting of profileSettingList\" [ngClass]=\"{'divider': setting.class === 'divider'}\" (click)=\"onProfileSettingSelected(setting)\"> <span>{{setting.title}}</span> </button> </mat-menu> </div> <img class=\"pen-navbar__site-logo\" *ngIf=\"siteLogo\" [src]=\"siteLogo\" /> </mat-toolbar>",
                    styles: [".pen-fill-space { flex: 1 1 auto; } .pen-uppercase { text-transform: uppercase; } .pen-navbar.mat-toolbar { height: 45px; padding: 0; position: fixed; top: 0; left: 0; right: 0; z-index: 999; box-shadow: 0 3px 5px -1px rgba(0, 0, 0, 0.2), 0 6px 10px 0 rgba(0, 0, 0, 0.14), 0 1px 18px 0 rgba(0, 0, 0, 0.12); } .pen-navbar .mat-toolbar-row { height: 45px; } .pen-navbar a:hover:not([disabled]), .pen-navbar a:focus:not([disabled]) { color: currentColor; text-decoration: none; outline: none; } .pen-navbar__activity-owner-list { max-width: 350px !important; } .pen-navbar__profile-settings { height: 100%; background-color: rgba(255, 255, 255, 0.95); color: #000; } .pen-navbar__profile-button { height: 100%; } .pen-navbar__profile-menu { width: 160px; margin-top: 4px; } .pen-navbar__profile-image { width: 30px; height: 30px; border-radius: 50%; } .pen-navbar__site-logo { height: 100%; background-color: rgba(255, 255, 255, 0.95); } .pen-navbar__child-level-1 { padding-left: 10px; } .pen-navbar__child-level-2 { padding-left: 20px; } .pen-navbar__child-level-3 { padding-left: 30px; } .pen-navbar__child-level-4 { padding-left: 40px; } .mat-menu-panel a:hover:not([disabled]), .mat-menu-panel a:focus:not([disabled]) { color: currentColor; text-decoration: none; outline: none; } .mat-menu-panel a[disabled]:hover, .mat-menu-panel a[disabled]:focus { text-decoration: none; outline: none; } .mat-menu-panel .divider { height: 1px; overflow: hidden; background-color: #e5e5e5; } a[hidden] { display: none !important; } "],
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    PenNavbarComponent.ctorParameters = function () { return []; };
    PenNavbarComponent.propDecorators = {
        "color": [{ type: Input },],
        "fullName": [{ type: Input },],
        "profileImage": [{ type: Input },],
        "siteLogo": [{ type: Input },],
        "selectedLanguage": [{ type: Input },],
        "options": [{ type: Input },],
        "languageList": [{ type: Input },],
        "profileSettingList": [{ type: Input },],
        "activityOwnerList": [{ type: Input },],
        "leftLinkList": [{ type: Input },],
        "rightLinkList": [{ type: Input },],
        "clickHomeIcon": [{ type: Output },],
        "clickToggleIcon": [{ type: Output },],
        "selectLanguage": [{ type: Output },],
        "selectProfileSetting": [{ type: Output },],
    };
    return PenNavbarComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var PenNavbarModule = (function () {
    function PenNavbarModule() {
    }
    PenNavbarModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        MatToolbarModule,
                        MatIconModule,
                        MatMenuModule,
                        MatButtonModule
                    ],
                    exports: [PenNavbarComponent],
                    declarations: [PenNavbarComponent],
                    providers: [],
                },] },
    ];
    /** @nocollapse */
    PenNavbarModule.ctorParameters = function () { return []; };
    return PenNavbarModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var PenetraceFrontendFoundationModule = (function () {
    function PenetraceFrontendFoundationModule() {
    }
    /**
     * @return {?}
     */
    PenetraceFrontendFoundationModule.forRoot = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: PenetraceFrontendFoundationModule,
            providers: []
        };
    };
    PenetraceFrontendFoundationModule.decorators = [
        { type: NgModule, args: [{
                    exports: [
                        PenSpinnerModule,
                        PenNavbarModule
                    ],
                    declarations: [],
                    providers: []
                },] },
    ];
    /** @nocollapse */
    PenetraceFrontendFoundationModule.ctorParameters = function () { return []; };
    return PenetraceFrontendFoundationModule;
}());

export { PenetraceFrontendFoundationModule, PenSpinnerModule, PenSpinnerComponent, PenNavbarModule, PenNavbarComponent };
